<!-- FuseMinderPlus.cfm by jeff.peters@bigfoot.com -->
<!---
<fusedoc fuse="FuseMinderPlus.cfm" language="ColdFusion" specification="2.0">
  <history author="jeff@grokfusebox.com" date="17 Aug 2001" type="Create">
  <responsibilities>
I read a text outline file and generate the specified Fusebox3-compliant framework, including fuseboxes and fusestubs.  If "attributes.location" is not defined, I use the current directory as home.  If "attributes.verbose" is TRUE or not defined, I produce progress statements while working.  If "attributes.indenter" is not defined, I use two spaces ("  ") as the outline indenting string.  If "attributes.mapper" is not defined, I use "". 
  </responsibilities>
  <in>
    <string name="outlineFile" scope="attributes" optional="No">
    <string name="location" scope="attributes" default="GetDirectoryFromPath(GetCurrentTemplatePath())">
    <boolean name="verbose" scope="attributes" default="FALSE">
    <string name="indenter" scope="attributes" default="  ">
    <string name="mapper" scope="attributes" default="">
  </in>
</fusedoc>
--->
<style type="text/css">
body {
 font-family: Verdana, Helvetica, sans-serif;
 font-size: 9pt;
}
.header {
 font-family: Verdana, Helvetica, sans-serif;
 font-size: 10pt;
 font-weight: bold;
}
.bg0 { background: #FFAAAA }
.bg1 { background: #AAFFAA }
.bg2 { background: #AAAAFF }
.bg3 { background: #FFFFAA }
.bg4 { background: #AAFFFF }
.bg5 { background: #FFAAFF }
</style>

<!--- Create array to track which circuit we're in according to line's depth. --->
<cfset aryInCircuit = ArrayNew(1)>

<cfparam name="attributes.OutlineFile" default="FuseMinderPlusDemo.txt">
<cfparam name="attributes.verbose" default="True">
<cfparam name="attributes.location" default="#GetDirectoryFromPath(GetCurrentTemplatePath())#">
<cfparam name="attributes.indenter" default="  ">
<cfparam name="attributes.mapper" default="">

<cfif attributes.verbose EQ "Yes">
  <cfoutput>
  <span class="header">
  FuseMinderPlus v 1.02 by Jeff Peters &lt;jeff@grokfusebox.com&gt;<br>
  </span>
  -- <strong>Run date:</strong> #Dateformat(Now())#, #TimeFormat(Now())# -- <strong>Outline File:</strong> #attributes.OutlineFile#
  </span>
  </cfoutput>
  <hr>
</cfif>

<cfset customTagPath = #GetDirectoryFromPath(GetCurrentTemplatePath())#>

<cfif IsDefined("attributes.OutlineFile") EQ "No">
  <cfthrow type="FuseMinderPlusError" message="OutlineFile not specified.">
</cfif>

<cfset circuitPath = "">
<cfset lastCircuitPath = "">
<cfset lastCircuitDepth = 0>

<!--- If attributes.location has a colon in it, we're in Windows, else Unix --->
<cfif Find(":",attributes.location) GT 0>
  <cfset slash = "\">
  <cfset Crlf = Chr(10)>
<cfelse>
  <cfset slash = "/">
  <cfset Crlf = Chr(13)>
</cfif>

<cfset lastLineType = "">
<cfset lastCircuit = "">
<cfset lastFuseaction = "">
<cfset modeEverybodyReadWrite = 666>

<!--- Fusebox file string constants --->
<cfset fbOpenLines = "<!--- Fusebox auto-generated by FuseMinderPlus --->#crlf##crlf#">
<cfset fbCloseLines = "  </cfcase>#Crlf#  <cfdefaultcase>#Crlf#    No handler for the fuseaction <cfoutput>##fusebox.fuseaction##</cfoutput>.#Crlf#  </cfdefaultcase>#Crlf#</cfswitch>">
<cfset fbOpenSwitch = "<cfswitch expression=""##fusebox.fuseaction##"">">
<cfset fbOpenCaseStart = "  <cfcase value=""">
<cfset fbOpenCaseEnd = """>">
<cfset fbIncludeStart = "    <cfinclude template=""">
<cfset fbIncludeEnd = """>">
<cfset loIncludeStart = "<cfinclude template=""">
<cfset loIncludeEnd = """>">
<cfset fbCloseCase = "  </cfcase>">
<cfset ctAliasDefStart = "<cfset fusebox.Circuits.">

<!--- Fuse file string constants --->
<cfset ffNoteLineStart = "<!-- ">
<cfset ffNoteLineEnd = " -->">
<cfset ffAuthor = "">

<!--- Set standard header lines for fbx_circuits.cfm--->
<cfset circHead = "<!---#crlf#">
<cfset circHead = circHead & "<fusedoc fuse=""fbx_Circuits.cfm"">#crlf#">
<cfset circHead = circHead & "  <responsibilities>#crlf#">
<cfset circHead = circHead & "    I define the Circuits structure used with Fusebox 3#crlf#">
<cfset circHead = circHead & "  </responsibilities> #crlf#">
<cfset circHead = circHead & "  <io>#crlf#    <out>#crlf#">
<cfset circHead = circHead & "      <string name=""fusebox.circuits.*"" comments=""set a variable for each circuit name"" />#crlf#">
<cfset circHead = circHead & "    </out>#crlf#  </io>#crlf#</fusedoc>#crlf#--->#crlf##crlf#">
<cfset circHead = circHead & "<!--- this file contains all the circuit definitions for the fusebox --->#crlf#">
<cfset circHead = circHead & "<cfset fusebox.Circuits.home = ""home"">">
<cfset fbx_circuitsHeader = circHead>
<cfset circHead = "">

<!--- Create a structure to hold circuit information --->
<cfset stuFuseboxes = StructNew()>

<!--- Read in outline file --->
<cftry>
  <cffile action="read" variable="strRawInput" file="#attributes.location##attributes.OutlineFile#">
  <cfcatch>
    <cfoutput>
    Error: Outline file #attributes.location##attributes.OutlineFile# does not exist.
    </cfoutput>
    <cfabort>
  </cfcatch>
</cftry>
<cfset aryOutline = ListToArray(strRawInput,crlf)>
          
<!--- For each line in outline: --->
<cfloop from="1" to="#ArrayLen(aryOutline)#" index="lineNum">
  <cfif (attributes.mapper EQ "MM") and (lineNum GT 1)>
    <cfset aryOutline[lineNum] = attributes.indenter & aryOutline[lineNum]>
  </cfif>

  <cfset trimmedLine = Trim(Replace(aryOutline[lineNum], attributes.indenter, "","ALL"))>
  <cfif Len(trimmedLine) GT 0>
    <!--- Take action based on node identifier --->
    <cfset lineType = "#Left(trimmedLine,3)#">
  	<cfswitch expression = "#lineType#">
      <!--- ************************************************************* --->
      <!---  Process a circuit node                                       --->
      <!--- ************************************************************* --->
      <cfcase value="ct:">
        <!--- Get line's depth by finding first non-space character in line. --->
        <cfset lineDepth = (REFind("[^#attributes.indenter#]",aryOutline[lineNum])-1)/Len(attributes.indenter)+1>
        <cfset outputIndent = RepeatString("&nbsp;&nbsp;",lineDepth)>
        <cfset circuitBG = lineDepth mod 6>
        <!--- Get circuit name, and alias if present --->
        <cfset circuitName = Trim(ListLast(aryOutline[lineNum],":"))>
        <cfif FindNoCase("(",circuitName)>
          <cfset circuitAlias = ListFirst(ListLast(circuitName,"("),")")>
          <cfset circuitName = Trim(ListFirst(circuitName,"("))>
        <cfelse>
          <cfset circuitAlias = circuitName>
        </cfif>
        
        <cfset circuitDepth = lineDepth>
        
        <!--- Put circuit's alias in the array slot for its level --->
        <cfset aryInCircuit[circuitDepth] = circuitAlias>
        
        <cfif circuitDepth EQ 1>
          <cfset rootNode = circuitName>
        </cfif>
        
        <!--- Determine circuit's path based on depth relationship to previous circuit. --->
        <cfif circuitDepth GT lastCircuitDepth>
     		  <cfset circuitPath="#lastCircuitPath##circuitName##slash#">
        <cfelseif circuitDepth LT lastCircuitDepth>
          <!--- Pop circuits off lastCircuitPath to this circuit's depth --->
          <cfset circuitPath = "">
          <cfloop from="1" to="#circuitDepth#" index="i">
            <cfset circuitPath = circuitPath & slash & ListGetAt(lastCircuitPath,i,slash)>
          </cfloop>
          <cfset circuitPath = "#circuitPath##slash#">
        <cfelse>
          <!--- Pop one circuit off lastCircuitPath to get the parent, then add this circuit. --->
          <cfset circuitPath = "">
          <cfloop from="1" to="#Evaluate(circuitDepth-1)#" index="i">
            <cfset circuitPath = circuitPath & slash & ListGetAt(lastCircuitPath,i,slash)>
          </cfloop>
          <cfset circuitPath = "#circuitPath##slash##circuitName##slash#">
        </cfif>
        
        <!--- Add a structure to stuFuseboxes for this circuit --->
        <cfset stuFuseboxes[circuitAlias] = structNew()>
        <cfset stuFuseboxes[circuitAlias].path = circuitPath>
        <cfset stuFuseboxes[circuitAlias].depth = circuitDepth>
        
        <!--- Set parent circuit path as one level above circuit path --->
        <cfset parentPath = "">
        <cfif ListLen(circuitPath,slash) GT 1>
          <cfloop from="1" to="#Evaluate(circuitDepth)#" index="i">
            <cfif Len(parentPath)>
              <cfset tempDelim = slash>
            <cfelse>
              <cfset tempDelim = "">
            </cfif>
            <cfset parentPath = parentPath & tempDelim & ListGetAt(circuitPath,i,slash)>
          </cfloop>
        </cfif>
        <cfset parentAlias = "#ListLast(parentPath,slash)#">
        <cfset parentPath = "#parentPath##slash#">
  
        <!--- Create the circuit directory; ignore error if it already exists. --->
  		  <cfset circuitClosed = "No">
  		  <cftry>
          <cfdirectory action="create" 
                    directory="#attributes.location##circuitPath#">
  			  <cfcatch type="Any">
  			  </cfcatch>
  		  </cftry>

    		<cfif attributes.verbose EQ "Yes">
          <cfoutput>
          <span class="bg#stuFuseboxes[circuitAlias].depth#">
    		  <strong>#outputIndent#Building #circuitAlias# circuit.</strong><br>
          </span>
          </cfoutput>
    		</cfif>
        
        <cfset switchFile = "#attributes.location##circuitPath#fbx_switch.cfm">
        
  		  <!--- If in main circuit, create fbx_circuits.cfm for circuit and write opening lines --->
        <cfif circuitDepth EQ 1>
          <cfset circuitsFile = "#attributes.location##circuitPath#fbx_circuits.cfm">
    		  <cftry>
    		    <cffile action="read" file="#circuitsFile#" variable="foo">
    			<cfcatch type="Any">
            <!--- Write standard lines to circuits file. --->
    			  <cffile action="APPEND"
    			                file="#circuitsFile#"
    		              output="#fbx_circuitsHeader#">
            <cfif attributes.verbose EQ "Yes">
              <cfoutput>
              <span class="bg#stuFuseboxes[circuitAlias].depth#">
              #outputIndent#fbx_circuits.cfm for #circuitName# circuit written.<br>
              </span>
              </cfoutput>
            </cfif>
    			</cfcatch>
          </cftry>
        </cfif>
        
        <!--- Create fbx_switch.cfm for circuit --->
  		  <cftry>
  		    <cffile action="read" file="#switchFile#" variable="foo">
  			<cfcatch type="Any">
  			  <!--- Write note line (first line of file) to switch file --->
  			  <cffile action="WRITE"
  			            mode="#modeEverybodyReadWrite#"
  	                    file="#switchFile#"
  				      output="#ffNoteLineStart#fbx_switch.cfm for #circuitAlias# circuit#ffAuthor##ffNoteLineEnd#">
          <!--- Write opening lines to switch file. --->
  			  <cffile action="APPEND"
  			                file="#switchFile#"
  		              output="#fbOpenLines#">
          <!--- Write opening line of cfswitch block to switch file. --->
  	  	  <cffile action="APPEND" 
  				          file="#switchFile#"
  					      output="#fbOpenSwitch#">
                    
          <cfif attributes.verbose EQ "Yes">
            <cfoutput>
            <span class="bg#stuFuseboxes[circuitAlias].depth#">
            #outputIndent#fbx_switch.cfm for #circuitName# circuit written.<br>
            </span>
            </cfoutput>
            <cfflush>
          </cfif>
  			</cfcatch>
        </cftry>
        
        <!-- Write a line for the circuit to the main app's circuits file --->
        <cfif circuitDepth GT 1>
          <cfset outputLine = "#Replace(circuitPath,"#slash#","/","ALL")#">
          <cfset outputLine = Reverse(Replace(Reverse(outputLine),"/","","ONE"))>
          <cfset outputLine = ListRest(outputLine,"/")>
          <cfset outputLine = "#ctAliasDefStart##circuitAlias# = ""home/#outputLine#"">">
          <cfset outputLine = Replace(outputLine,"//","/","ALL")>
          <cffile action="APPEND"
                    file="#circuitsFile#"
        	        output="#outputLine#">
        </cfif>
        
        <!--- Set variables to differentiate from next circuit line --->
  			<cfset lastCircuit = circuitAlias>
        <cfset lastCircuitDepth = circuitDepth>
        <cfset lastCircuitPath = circuitPath>
        <!--- Clear lastFuseaction variable (circuit-specific) --->
        <cfset lastFuseaction = "">
        <cfset lastNodeType = lineType>
  		</cfcase>
  
      <!--- ************************************************************* --->
      <!---  Process a fuseaction node                                    --->
      <!--- ************************************************************* --->
  		<cfcase value="fa:">
        <!--- Get line's depth by finding first non-space character in line. --->
        <cfset lineDepth = (REFind("[^#attributes.indenter#]",aryOutline[lineNum])-1)/Len(attributes.indenter)+1>
        <cfset outputIndent = RepeatString("&nbsp;&nbsp;",lineDepth)>
        <!--- Check which circuit we're in for this fuseaction's level --->
        <cfset myCircuitAlias = aryInCircuit[lineDepth-1]>
        <cfset myCircuitPath = stuFuseboxes[myCircuitAlias].path>

  		  <cfset fuseactionName = "#Trim(ListLast(aryOutline[lineNum],":"))#">
  		  <!--- If lastFuseaction is not this fuseaction name and not empty, write 
  			    case closing line to appropriate circuit's fusebox.--->
  		  <cfif ((lastFuseaction NEQ "") AND (lastFuseaction NEQ fuseactionName))>
          <cfif myCircuitAlias EQ lastCircuit>
  	  	    <cffile action="APPEND" 
  					          file="#attributes.location##myCircuitPath#fbx_switch.cfm"
  					        output="#fbCloseCase#">
          <cfelse>
  	  	    <cffile action="APPEND" 
  					          file="#attributes.location##lastCircuitPath#fbx_switch.cfm"
  					        output="#fbCloseCase#">          
  			  </cfif>
  		  </cfif>
        
  		  <!--- Append fuseaction's cfcase line to circuit's fusebox --->
  		  <cffile action="APPEND"
                      file="#attributes.location##myCircuitPath#fbx_switch.cfm"
  			      output="#fbOpenCaseStart##fuseactionName##fbOpenCaseEnd#">
  		  <!--- Set lastFuseaction = fuseactionName --->
  		  <cfset lastFuseaction = "#fuseactionName#">
  		  <cfif attributes.verbose EQ "Yes">
          <cfoutput>
          <span class="bg#stuFuseboxes[myCircuitAlias].depth#">
  		    #outputIndent#Fuseaction #fuseactionName# written.<br>
          </span>
          </cfoutput>
          <cfflush>
  		  </cfif>
        <cfset myCircuitAlias = "">
        <cfset myCircuitPath = "">
        <cfset lastNodeType = lineType>
  		</cfcase>
  
      <!--- ************************************************************* --->
      <!---  Process a fuse file node                                     --->
      <!--- ************************************************************* --->
  		<cfcase value="ff:">
        <!--- Get line's depth by finding first non-space character in line. --->
        <cfset lineDepth = (REFind("[^#attributes.indenter#]",aryOutline[lineNum])-1)/Len(attributes.indenter)+1>
        <cfset outputIndent = RepeatString("&nbsp;&nbsp;",lineDepth)>
        <cfset myCircuitAlias = aryInCircuit[lineDepth-2]>
        <cfset myCircuitPath = stuFuseboxes[myCircuitAlias].path>

  		  <cfset fuseFile = "#Trim(ListLast(aryOutline[lineNum],":"))#">
  		  <!--- Append cfinclude line to fusebox for parent circuit --->
  		  <cffile action="APPEND"
                      file="#attributes.location##myCircuitPath#fbx_switch.cfm"
  			      output="#fbIncludeStart##fuseFile##fbIncludeEnd#">
  		  <!--- Write note line (first line of file) to fuse file --->
  		  <cffile action="WRITE"
  		            mode="#modeEverybodyReadWrite#"
                      file="#attributes.location##myCircuitPath##fuseFile#"
  			      output="#ffNoteLineStart##fuseFile##ffAuthor##ffNoteLineEnd#">
  	      <cfif attributes.verbose EQ "Yes">
            <cfoutput>
            <span class="bg#stuFuseboxes[myCircuitAlias].depth#">
            #outputIndent#Fuse #fuseFile# written.<br>
            </span>
            <cfflush>
            </cfoutput>
  		  </cfif>
        <cfset myCircuitAlias = "">
        <cfset myCircuitPath = "">
        <cfset lastNodeType = lineType>
  		</cfcase>
      
      <!--- ************************************************************* --->
      <!---  Process a direct file node                                  --->
      <!--- ************************************************************* --->
      <cfcase value="df:">
        <!--- Get line's depth by finding first non-space character in line. --->
        <cfset lineDepth = (REFind("[^#attributes.indenter#]",aryOutline[lineNum])-1)/Len(attributes.indenter)+1>
        <cfset outputIndent = RepeatString("&nbsp;&nbsp;",lineDepth)>
        <cfset myCircuitAlias = aryInCircuit[lineDepth-1]>
        <cfset myCircuitPath = stuFuseboxes[myCircuitAlias].path>

  		  <cfset fuseFile = "#Trim(ListLast(aryOutline[lineNum],":"))#">
  		  <!--- Write note line (first line of file) to file --->
  		  <cffile action="WRITE"
  		            mode="#modeEverybodyReadWrite#"
                      file="#attributes.location##myCircuitPath##fuseFile#"
  			      output="#ffNoteLineStart##fuseFile##ffAuthor##ffNoteLineEnd#">
  	      <cfif attributes.verbose EQ "Yes">
            <cfoutput>
            <span class="bg#stuFuseboxes[myCircuitAlias].depth#">
            #outputIndent#File #fuseFile# written.<br>
              </span>
            </cfoutput>
            <cfflush>
  		    </cfif>
        <cfset myCircuitAlias = "">
        <cfset myCircuitPath = "">
        <cfset lastNodeType = lineType>
      </cfcase>
  
      <!--- ************************************************************* --->
      <!---  Process a layout file node                                   --->
      <!--- ************************************************************* --->
      <cfcase value="lo:">
        <!--- Get line's depth by finding first non-indenter character in line. --->
        <cfset lineDepth = (REFind("[^#attributes.indenter#]",aryOutline[lineNum])-1)/Len(attributes.indenter)+1>
        <cfset outputIndent = RepeatString("&nbsp;&nbsp;",lineDepth)>
        <!--- Check which circuit we're in for this layout file's level --->
        <cfset myCircuitAlias = aryInCircuit[lineDepth-1]>
        <cfset myCircuitPath = stuFuseboxes[myCircuitAlias].path>

  		  <cfset fuseFile = "#Trim(ListLast(aryOutline[lineNum],":"))#">
  		  <!--- Add layout specification to stuFuseboxes for circuit --->
        <cfset stuFuseboxes[myCircuitAlias].layout = fuseFile>
  		  <!--- Write note line (first line of file) to layout file --->
  		  <cffile action="WRITE"
  		            mode="#modeEverybodyReadWrite#"
                      file="#attributes.location##myCircuitPath##fuseFile#"
  			      output="#ffNoteLineStart##fuseFile##ffAuthor##ffNoteLineEnd#">
 	      <cfif attributes.verbose EQ "Yes">
          <cfoutput>
          <span class="bg#stuFuseboxes[myCircuitAlias].depth#">
          #outputIndent#Layout file #fuseFile# written.<br>
          </span>
          </cfoutput>
          <cfflush>
  		  </cfif>
        <cfset myCircuitAlias = "">
        <cfset myCircuitPath = "">
        <cfset lastNodeType = lineType>
      </cfcase>
  
  		<cfdefaultcase>
        <!--- Set an offset based on the type of node the line belongs to. --->
        <cfswitch expression="#lastNodeType#">
          <cfcase value="ff:">
            <cfset nodeOffset = 2>
          </cfcase>
          <cfcase value="df:">
            <cfset nodeOffset = 1>
          </cfcase>
          <cfcase value="lo:">
            <cfset nodeOffset = 1>
          </cfcase>
          <cfdefaultcase>
            <cfset nodeOffset = 0>
          </cfdefaultcase>
        </cfswitch>
      
        <cfset myCircuitAlias = aryInCircuit[lineDepth-nodeOffset]>
        <cfset myCircuitPath = stuFuseboxes[myCircuitAlias].path>

        <!--- Peel indenters off line --->
        <cfif len(attributes.indenter) EQ 1>
          <cfset leftJustLine = ListFirst(aryOutline[lineNum],attributes.indenter)>
        <cfelse>
          <cfset leftJustLine = aryOutline[lineNum]>
          <cfset leftJustLine = Right(leftJustLine,len(leftJustLine)-(len(attributes.indenter)*lineDepth))>
        </cfif>
  		  <!--- Append file content line to current file --->
  		  <cffile action="APPEND"
                  file="#attributes.location##myCircuitPath##fuseFile#"
  			        output="#leftJustLine#"
            addnewline="No">
  		</cfdefaultcase>
  	</cfswitch>
  	<cfset lastLineType=lineType>
  </cfif>
</cfloop>

<!--- Write switch closing lines and layout definitions for fuseboxes in stuFuseboxes --->
<cfloop collection="#stuFuseboxes#" item="fusebox">
  <cfset fbPath = stuFuseboxes[fusebox].path>
  <cffile action="APPEND" 
	          file="#attributes.location##fbPath#fbx_switch.cfm"
	        output="#fbCloseLines#">
  <!--- If there is a layout file, write a definition line for it. --->
  <cfif StructKeyExists(stuFuseboxes[fusebox],"layout")>
    <cfset layoutLine = "<cfset fusebox.layoutFile=""" & stuFuseboxes[fusebox].layout & """>">
    <cffile action="APPEND" 
  	          file="#attributes.location##fbPath#fbx_layout.cfm"
  	        output="#layoutLine#">
  </cfif>
</cfloop>
		
<!-- Output end of process message --->
<cfif attributes.verbose EQ "Yes">
  <span class="header">
  Application build complete.<br>
  </span>
  <hr>
  &copy; 2000-2002 All Rights Reserved
</cfif>
